#
# release-helmchart-job definition
#

#
# defaults
#


variables:
  HELM_PROJECT: $CI_PROJECT_NAME
  CHART_PATH: charts
  CHART_TARGET: helm-chart
  HELM_CHART_DIRS: ""

#
# jobs
#

echo-helmchart-vars-job:
  extends: 
    - .set-version-vars
  stage: releasing
  image: alpine/helm
  rules:
    - if: $DEBUG =~ /release/
  script:
    - apk add gettext
    - cp -r ${CHART_PATH} ${CHART_TARGET}
    - echo "PROJECT_RELEASE_VERSION= ${PROJECT_RELEASE_VERSION}"
    - echo "Helm Repo url= ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/helm/stable"
    - cat ${CHART_PATH}/Chart.yaml | envsubst > ${CHART_TARGET}/Chart.yaml
    - cat ${CHART_PATH}/values.yaml | envsubst > ${CHART_TARGET}/values.yaml
    - cat ${CHART_TARGET}/Chart.yaml
    - cat ${CHART_TARGET}/values.yaml

release-helmchart-job:
  extends: 
    - .set-version-vars
  stage: releasing
  image: alpine/helm
  rules:
    - if: $RUN_SAST_SCA_REPORT
      when: never
    - exists:
        - ${CHART_PATH}/Chart.yaml
      if:  $CI_COMMIT_TAG == null && (($CI_COMMIT_REF_SLUG !~ /^feature/ && $DEBUG == null) || ($CI_COMMIT_REF_SLUG =~ /^feature/ && $RUN_CHART != null))
    - if: $CI_COMMIT_TAG
      when: never


#  before_script:
  script:
    - helm repo add --username gitlab-ci-token --password ${CI_JOB_TOKEN} ${CI_PROJECT_NAME} ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/helm/stable
    - apk add gettext
    - cp -r ${CHART_PATH} ${CHART_TARGET}
    - cat ${CHART_PATH}/Chart.yaml | envsubst > ${CHART_TARGET}/Chart.yaml
    - cat ${CHART_PATH}/values.yaml | envsubst > ${CHART_TARGET}/values.yaml
    - for folder in $HELM_CHART_DIRS; do
    - if [ -d "$folder" ]; then
    -   echo "Copying $folder"
    -   cp -r "$folder" "${CHART_TARGET}"
    -   find "$folder" -type f -name "*values*.yaml" | while read file; do
    -      echo "Copy and replace $file to $CHART_TARGET"
    -      cat $file | envsubst > ${CHART_TARGET}/$file
    -   done
    - else
    -   echo "Warning! $folder is not a valid directory, skipping..."
    - fi
    - done
  
    - helm package ${CHART_TARGET}
    - helm plugin install https://github.com/chartmuseum/helm-push.git
    - helm cm-push ${CHART_TARGET} ${HELM_PROJECT}
